sub avpdaemon_scanner {
  #Kaspersky  AVPDaemonClient scanner
  &debug("avp: starting scan of directory \"$ENV{'TMPDIR'}\"...",5);
  my ($start_avpdaemon_time)=[gettimeofday];
  my ($DD,$avpdaemon_status,$stop_avpdaemon_time,$avpdaemon_time);
  &debug("avp: run $avpdaemon_binary  $ENV{'TMPDIR'} 2>&1",5);
  $DD=`$avpdaemon_binary  $ENV{'TMPDIR'}  2>&1`;
  $avpdaemon_status=($? >> 8);
  &debug("avp: --output of avpdaemon was:\n$DD--",5);
  if ( $avpdaemon_status > 0 || ($DD =~ /Test result: 4/ && $avpdaemon_status == 0)) {
    &debug("First test Avpdaemon OK, virus found somewhere",5);
    if ($DD =~ /(.*)[Ii]nfected: (.*)\n/) {
      $quarantine_description=$2;
      &debug("avp: At least one virus was found! ($quarantine_description)",2);
      $quarantine_event++;
      $description .= "\n---avpdaemon results ---\n$DD";
    }
    elsif ($DD =~ /(.*)[Ss]uspicion: (.*)\n/) {
      $quarantine_description=$2;
      &debug("avp: there be a virus! ($quarantine_description)",1);
      $quarantine_event++;
      $description .= "\n---avpdaemon results ---\n$DD";
    }
    elsif ($DD =~ /(.*)[Cc]orrupted:(.*)[^0]+(.*)\n/) {
      $quarantine_description=$2;
      &debug("avp: Corrupted file in attachment ($quarantine_description)",5);
      $quarantine_event++;
      $description .= "\n---avpdaemon results ---\n$DD";
    } else {
      # This implies a corrupt set of DAT files or resource problems...
      # or a not running AvpDaemon
      # &tempfail("corrupt or unknown Kaspersky scanner problems - exit status $avpdaemon_status");
    }
  }
  $stop_avpdaemon_time=[gettimeofday];
  $avpdaemon_time = tv_interval ($start_avpdaemon_time, $stop_avpdaemon_time);
  &debug("avp: finished scan in $avpdaemon_time secs",2);
}
