sub avp_scanner {
  #Kaspersky  AVPLinux scanner
  &debug("kasp: starting scan of directory \"$ENV{'TMPDIR'}\"...",5);
  my ($start_avp_time)=[gettimeofday];
  my ($avp_verbose,$DD,$avp_status,$eavp_status,$stop_avp_time,$avp_time);
  $avp_verbose="-j2" if ($DEBUG);
  &debug("Setting enviroment \$TEMP to $ENV{'TMPDIR'}",5);
  $ENV{'TEMP'} = $ENV{'TMPDIR'};
  &debug("run $avp_binary -i0 -xp $avp_verbose $ENV{'TMPDIR'}  2>&1",5);
  $DD=`$avp_binary -i0 -xp $avp_verbose $ENV{'TMPDIR'}  2>&1`;
  # Removing CRLF windows chars
  $DD =~ s/\r//g;
  $avp_status=$?;
  $eavp_status=($avp_status >> 8);

  &debug("--output of avp was:\n$DD--",5);
  if ( $eavp_status !~ /^(0|10|15)$/ ) {
    if ($eavp_status =~ /^(5|20|21|25)$/) {
      #This covers the potential viruses
      $quarantine_description="suspicious";
      if ($DD =~ /\n(.*) (infected):? (.*)\n/i) {
	$quarantine_description=$3;
      } elsif ($DD =~ /\n(.*) (suspic\w+):? (.*)\n/i) {
	#This covers the specific
	$destring='Suspicious file:';
	$quarantine_description=$3;
      }
      &debug("kasp: there be a virus! ($quarantine_description)",1);
      ($quarantine_event=$quarantine_description)=~s/\s/_/g;
      $quarantine_event="AVP:".substr($quarantine_event,0,$QE_LEN);
    } else {
      &error_condition("corrupt or unknown Kaspersky scanner error or memory/resource/perms problems - exit status $avp_status/$eavp_status");
    }
  } elsif ($eavp_status == 0 && $avp_status > 0) {
    &error_condition("corrupt or unknown Kaspersky scanner error or memory/resource/perms problems - exit status $avp_status/$eavp_status");
  }
  $stop_avp_time=[gettimeofday];
  $avp_time = tv_interval ($start_avp_time, $stop_avp_time);
  &debug("Deleting enviroment \$TEMP",5);
  delete $ENV{'TEMP'};
  &debug("kasp: finished scan in $avp_time secs",2);
}
