sub csav_scanner {
  #Command scanner
  &debug("csav_scanner: starting scan of directory \"$ENV{'TMPDIR'}\"...",5);
  my ($start_csav_time)=[gettimeofday];
  my ($DD,$csav_status,$ecsav_status,$stop_csav_time,$csav_time,$csav_verbose,$csav_list);
  my $options = "-nomem -packed -archive -noboot";
  $csav_verbose="-silent" if (!$DEBUG);
  $csav_list="-list" if ($DEBUG);

  my ($cmd);
  $cmd="$csav_binary $csav_verbose $csav_list $options $ENV{'TMPDIR'} 2>&1";
  &debug("csav_scanner: $cmd",5);
  $DD =`$cmd`;
  $csav_status=$?;
  $ecsav_status=($csav_status >> 8);

  if ($DD =~ / Infection: (.*)/) {
    $quarantine_description=$1;
    &debug("csav_scanner: there be a virus! ($quarantine_description)",1);
    ($quarantine_event=$quarantine_description)=~s/\s/_/g;
    $quarantine_event="CSAV:".substr($quarantine_event,0,$QE_LEN);
  }  
  
  $stop_csav_time=[gettimeofday];
  $csav_time = tv_interval ($start_csav_time, $stop_csav_time);
  &debug("csav_scanner: finished scan in $csav_time secs",2);
}
