sub decode_base64 {
	my ($str)=@_;
	$str=~ tr|A-Za-z0-9+=/||cd;     # remove non-base64 chars
	if (length($str) % 4) {
		print "Well this is illegal - block\n";
		exit;
	}
	$str=~s/=+$//;		   # remove padding
	$str =~ tr|A-Za-z0-9+/| -_|;    # convert to uuencoded format
    	return "" unless length $str;

    	my $uustr = '';
    	my ($i, $l);
    	$l = length($str) - 60;
    	for ($i = 0; $i <= $l; $i += 60) {
        	$uustr .= "M" . substr($str, $i, 60);
    	}
    	$str = substr($str, $i);
    	# and any leftover chars
    	if ($str ne "") {
        	$uustr .= chr(32 + length($str)*3/4) . $str;
    	}
    	return unpack ("u", $uustr);
}

sub decode_qp {
   
    my ($res) = @_;
    $res =~ s/\r\n/\n/g;            # normalize newlines
    $res =~ s/[ \t]+\n/\n/g;        # rule #3 (trailing space must be deleted)
    $res =~ s/=\n//g;               # rule #5 (soft line breaks)
    if (ord('A') == 193) { # EBCDIC style machine
        if (ord('[') == 173) {
            $res =~ s/=([\da-fA-F]{2})/Encode::encode('cp1047',Encode::decode('i
so-8859-1',pack("C", hex($1))))/ge;
        }
        elsif (ord('[') == 187) {
            $res =~ s/=([\da-fA-F]{2})/Encode::encode('posix-bc',Encode::decode(
'iso-8859-1',pack("C", hex($1))))/ge;
        }
        elsif (ord('[') == 186) {
            $res =~ s/=([\da-fA-F]{2})/Encode::encode('cp37',Encode::decode('iso
-8859-1',pack("C", hex($1))))/ge;
        }
    }
    else { # ASCII style machine
        $res =~ s/=([\da-fA-F]{2})/pack("C", hex($1))/ge;
    }
    $res;
}

