sub ravlin_scanner {
  #RAV scanner
  &debug("ravlin_scanner: starting scan of directory \"$ENV{'TMPDIR'}\"...",5);
  my ($start_ravlin_time)=[gettimeofday];
  my ($cmd,$DD,$ravlin_status,$stop_ravlin_time,$ravlin_time,$ravlin_verbose);
  my $ravlin_options = "--mail --archive --heuristics=on --all";
  $ravlin_verbose="--listall" if ($DEBUG);

  $cmd="$ravlin_binary $ravlin_verbose  $ravlin_options $ENV{'TMPDIR'} 2>&1";
  &debug("ravlin_scanner: $cmd",5);
  $DD =`$cmd`;
  $ravlin_status=($? >> 8);
  $DD =~ s/\r//g;
  $DD =~ s/[\ ]+/ /g;
  &debug("ravlin_scanner: $DD, exit status $ravlin_status",5);
  
  #Bizarre: ravav has an exit status of "1" for a clean file - but I still see "0" too!
  if ($ravlin_status <= 1) {
    #This msg is OK
  } elsif ($ravlin_status > 1 && $ravlin_status < 20) {
    if ($DD =~ ?$scandir.* Infected: (.*)$?m) {
      $quarantine_description=$1;
      &debug("ravlin_scanner: there be a virus! ($quarantine_description)",1);
      ($quarantine_event=$quarantine_description)=~s/\s/_/g;
      $quarantine_event="RAV:".substr($quarantine_event,0,$QE_LEN);
      $description .= "\n---ravlin results ---\n$DD";
    } else {
      &debug("ravlin_scanner: Whoops! Found a virus - but no description!",1);
      &error_condition("unknown Ravlin scanner virus found but not described - exit status $ravlin_status");
    }
  } else {
    &debug("ravlin_scanner: Whoops! Something went wrong - requeue",2);
    &error_condition("corrupt or unknown Ravlin scanner error or memory/resource/perms problem - exit status $ravlin_status");
  }
  $stop_ravlin_time=[gettimeofday];
  $ravlin_time = tv_interval ($start_ravlin_time, $stop_ravlin_time);
  &debug("ravlin_scanner: finished scan in $ravlin_time secs",2);
}
